; ---------------------------------------------------------------------------------------------
; Programa para testes dos servicos de terminais.
;
; STATUS: FUNCIONA
;
; Este programa testa as macros e rotinas do servico para terminais.
;
; Este programa foi testado no HyperTerminal do Windows numa sessao de 9600BPS, 8 bits, 
; sem controle de fluxo e 1 bit de paridade. (9600 8-N-1)
;
; HARDWARE USADO
; ------------------------------------
; Microcontrolador ............... PIC18F4520
; pino 13 e 14 (OSC1 e OSC2) ..... Cristal 20MHZ
; Pino 25 - RC6 .................. Tx da USART
; Pino 26 - RC7 .................. Rx da USART
;
;
; MODULOS USADOS
; ------------------------------------
; familias.inc ................... Definicao de simbolos 
; terminal_services.inc .......... Servico de Terminais
; string_services.inc ............ Servico de strings
;
; ---------------------------------------------------------------------------------------------
;
        LIST P=18f4520 
        #include <P18F4520.INC>

; ---------------------------------------------------------------------------------------------
; CONFIGURATION BITS ou FUSES
; ---------------------------------------------------------------------------------------------
    CONFIG WDT   = OFF
	CONFIG MCLRE = ON
	CONFIG DEBUG = OFF
	CONFIG LVP   = OFF 
    CONFIG OSC   = HS

; ---------------------------------------------------------------------------------------------
; MACROS
; ---------------------------------------------------------------------------------------------

             #include  "familias.inc"

; ---------------------------------------------------------------------------------------------
; RAM
; ---------------------------------------------------------------------------------------------
              UDATA   0x80
delay_temp    res     .1
CLOCK         equ     20000000

str_dlm       RES     1
str_reg1      RES     1
str_reg2      RES     1
str_reg3      RES     1
str_reg4      RES     1
str_reg5      RES     1
str_reg6      RES     1
str_ptr       RES     1

str_buffer    equ     0x300     ; buffer para tratamento de strings
ser_buff      equ     0x380     ; buffer de terminal

; ---------------------------------------------------------------------------------------------
pwron      CODE    0x0000
           goto    inicio
;
intrf      CODE    0x008
           retfie
;
; ---------------------------------------------------------------------------------------------
;
MAIN       CODE
           #include "terminal_services.inc"      ; <== Servico de Terminais
           #include "string_services.inc"        ; <== Servico de strings

inicio     movlw   0x0F                          ;  
           movwf   ADCON1                        ; todas as portas sao I/O digital

           DLMSET  0x0D                          ; delimitador de strings

           ; Configura o terminal
           TERM_CONFIG  .9600, .20000000, ASYNCH, NOINTERRUPT, COMPAT 

           TERM_CLEAR
kbdget     TERM_STR "TECLE ENTER...", nl
           TERM_READ    ser_buff, SL   
           TERM_NL

           TERM_STR     "TESTE ", null

           movlw  "D"
           TERM_PUT
           movlw  "O"
           TERM_PUT
           movlw  " "
           TERM_PUT

           TERM_PUTCHAR "T"
           TERM_PUTCHAR "E"
           TERM_PUTCHAR "R"
           TERM_PUTCHAR "M"
           TERM_PUTCHAR "I"
           TERM_PUTCHAR "N"
           TERM_PUTCHAR "A"
           TERM_PUTCHAR "L"
           TERM_NL

           TERM_STR "O TERMINAL FUNCIONOU!!!", nl
  
           goto  kbdget
  END





